diff --git a/gnome-session/gsm-client.h b/gnome-session/gsm-client.h
index 120dbda7..dbd9da41 100644
--- a/gnome-session/gsm-client.h
+++ b/gnome-session/gsm-client.h
@@ -26,24 +26,88 @@
 
 G_BEGIN_DECLS
 
+#define GSM_TYPE_CLIENT            (gsm_client_get_type ())
+G_DECLARE_DERIVABLE_TYPE (GsmClient, gsm_client, GSM, CLIENT, GObject)
+
+typedef struct _GsmApp           GsmApp;
+typedef struct _GsmClient        GsmClient;
+typedef struct _GsmClientClass   GsmClientClass;
+
+typedef enum {
+        GSM_CLIENT_UNREGISTERED = 0,
+        GSM_CLIENT_REGISTERED,
+        GSM_CLIENT_FINISHED,
+        GSM_CLIENT_FAILED
+} GsmClientStatus;
+
+typedef enum {
+        GSM_CLIENT_RESTART_NEVER = 0,
+        GSM_CLIENT_RESTART_IF_RUNNING,
+        GSM_CLIENT_RESTART_ANYWAY,
+        GSM_CLIENT_RESTART_IMMEDIATELY
+} GsmClientRestartStyle;
+
 typedef enum {
-        GSM_CLIENT_END_SESSION_FLAG_NONE = 0,
         GSM_CLIENT_END_SESSION_FLAG_FORCEFUL = 1 << 0,
+        GSM_CLIENT_END_SESSION_FLAG_SAVE     = 1 << 1,
+        GSM_CLIENT_END_SESSION_FLAG_LAST     = 1 << 2
 } GsmClientEndSessionFlag;
 
-#define GSM_TYPE_CLIENT            (gsm_client_get_type ())
-G_DECLARE_FINAL_TYPE (GsmClient, gsm_client, GSM, CLIENT, GObject)
+struct _GsmClientClass
+{
+        GObjectClass parent_class;
+
+        /* signals */
+        void         (*disconnected)               (GsmClient  *client);
+        void         (*end_session_response)       (GsmClient  *client,
+                                                    gboolean    ok,
+                                                    gboolean    do_last,
+                                                    gboolean    cancel,
+                                                    const char *reason);
+
+        /* virtual methods */
+        char *                (*impl_get_app_name)           (GsmClient *client);
+        GsmClientRestartStyle (*impl_get_restart_style_hint) (GsmClient *client);
+        guint                 (*impl_get_unix_process_id)    (GsmClient *client);
+        gboolean              (*impl_query_end_session)      (GsmClient *client,
+                                                              GsmClientEndSessionFlag flags,
+                                                              GError   **error);
+        gboolean              (*impl_end_session)            (GsmClient *client,
+                                                              GsmClientEndSessionFlag flags,
+                                                              GError   **error);
+        gboolean              (*impl_cancel_end_session)     (GsmClient *client,
+                                                              GError   **error);
+        gboolean              (*impl_stop)                   (GsmClient *client,
+                                                              GError   **error);
+        GKeyFile *            (*impl_save)                   (GsmClient *client,
+                                                              GsmApp    *app,
+                                                              GError   **error);
+};
 
-GsmClient *           gsm_client_new                        (const char *app_id,
-                                                             const char *bus_name);
+typedef enum
+{
+        GSM_CLIENT_ERROR_GENERAL = 0,
+        GSM_CLIENT_ERROR_NOT_REGISTERED,
+        GSM_CLIENT_NUM_ERRORS
+} GsmClientError;
+
+#define GSM_CLIENT_ERROR gsm_client_error_quark ()
+GQuark                gsm_client_error_quark                (void);
 
 const char           *gsm_client_peek_id                    (GsmClient  *client);
-const char *          gsm_client_peek_bus_name              (GsmClient  *client);
 
+
+const char *          gsm_client_peek_startup_id            (GsmClient  *client);
 const char *          gsm_client_peek_app_id                (GsmClient  *client);
+guint                 gsm_client_peek_restart_style_hint    (GsmClient  *client);
+guint                 gsm_client_peek_status                (GsmClient  *client);
+
 
+char                 *gsm_client_get_app_name               (GsmClient  *client);
 void                  gsm_client_set_app_id                 (GsmClient  *client,
                                                              const char *app_id);
+void                  gsm_client_set_status                 (GsmClient  *client,
+                                                             guint       status);
 
 gboolean              gsm_client_end_session                (GsmClient                *client,
                                                              GsmClientEndSessionFlag   flags,
@@ -54,8 +118,23 @@ gboolean              gsm_client_query_end_session          (GsmClient
 gboolean              gsm_client_cancel_end_session         (GsmClient  *client,
                                                              GError    **error);
 
+void                  gsm_client_disconnected               (GsmClient  *client);
+
+GKeyFile             *gsm_client_save                       (GsmClient  *client,
+                                                             GsmApp     *app,
+                                                             GError    **error);
+
 gboolean              gsm_client_stop                       (GsmClient  *client,
                                                              GError    **error);
+
+/* private */
+
+void                  gsm_client_end_session_response       (GsmClient  *client,
+                                                             gboolean    is_ok,
+                                                             gboolean    do_last,
+                                                             gboolean    cancel,
+                                                             const char *reason);
+
 G_END_DECLS
 
 #endif /* __GSM_CLIENT_H__ */
diff --git a/gnome-session/gsm-dbus-client.c b/gnome-session/gsm-dbus-client.c
new file mode 100644
index 00000000..746b1e02
--- /dev/null
+++ b/gnome-session/gsm-dbus-client.c
@@ -0,0 +1,439 @@
+/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
+ *
+ * Copyright (C) 2008 Red Hat, Inc.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "config.h"
+
+#include <fcntl.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <stdarg.h>
+#include <string.h>
+#include <time.h>
+#include <unistd.h>
+#include <gio/gio.h>
+
+#include "org.gnome.SessionManager.ClientPrivate.h"
+#include "gsm-dbus-client.h"
+
+#include "gsm-manager.h"
+#include "gsm-util.h"
+
+#define SM_DBUS_NAME                     "org.gnome.SessionManager"
+#define SM_DBUS_CLIENT_PRIVATE_INTERFACE "org.gnome.SessionManager.ClientPrivate"
+
+struct _GsmDBusClient
+{
+        GObject               parent_instance;
+
+        char                 *bus_name;
+        GPid                  caller_pid;
+        GsmClientRestartStyle restart_style_hint;
+
+        GDBusConnection      *connection;
+        GsmExportedClientPrivate *skeleton;
+        guint                 watch_id;
+};
+
+typedef enum {
+        PROP_BUS_NAME = 1,
+} GsmDBusClientProperty;
+
+static GParamSpec *props[PROP_BUS_NAME + 1] = { NULL, };
+
+G_DEFINE_TYPE (GsmDBusClient, gsm_dbus_client, GSM_TYPE_CLIENT)
+
+static gboolean
+setup_connection (GsmDBusClient *client)
+{
+        GError *error = NULL;
+
+        if (client->connection == NULL) {
+                client->connection = g_bus_get_sync (G_BUS_TYPE_SESSION, NULL, &error);
+                if (error != NULL) {
+                        g_debug ("GsmDbusClient: Couldn't connect to session bus: %s",
+                                 error->message);
+                        g_error_free (error);
+                        return FALSE;
+                }
+        }
+
+        return TRUE;
+}
+
+static gboolean
+handle_end_session_response (GsmExportedClientPrivate *skeleton,
+                             GDBusMethodInvocation    *invocation,
+                             gboolean                  is_ok,
+                             const char               *reason,
+                             GsmDBusClient            *client)
+{
+        g_debug ("GsmDBusClient: got EndSessionResponse is-ok:%d reason=%s", is_ok, reason);
+        gsm_client_end_session_response (GSM_CLIENT (client),
+                                         is_ok, FALSE, FALSE, reason);
+
+        gsm_exported_client_private_complete_end_session_response (skeleton, invocation);
+        return TRUE;
+}
+
+static GObject *
+gsm_dbus_client_constructor (GType                  type,
+                             guint                  n_construct_properties,
+                             GObjectConstructParam *construct_properties)
+{
+        GsmDBusClient *client;
+        GError *error = NULL;
+        GsmExportedClientPrivate *skeleton;
+
+        client = GSM_DBUS_CLIENT (G_OBJECT_CLASS (gsm_dbus_client_parent_class)->constructor (type,
+                                                                                              n_construct_properties,
+                                                                                              construct_properties));
+
+        if (! setup_connection (client)) {
+                g_object_unref (client);
+                return NULL;
+        }
+
+        skeleton = gsm_exported_client_private_skeleton_new ();
+        client->skeleton = skeleton;
+        g_debug ("exporting dbus client to object path: %s", gsm_client_peek_id (GSM_CLIENT (client)));
+        g_dbus_interface_skeleton_export (G_DBUS_INTERFACE_SKELETON (skeleton),
+                                          client->connection,
+                                          gsm_client_peek_id (GSM_CLIENT (client)),
+                                          &error);
+
+        if (error != NULL) {
+                g_critical ("error exporting client private on session bus: %s", error->message);
+                g_error_free (error);
+                g_object_unref (client);
+                return NULL;
+        }
+
+        g_signal_connect (skeleton, "handle-end-session-response",
+                          G_CALLBACK (handle_end_session_response), client);
+
+        return G_OBJECT (client);
+}
+
+static void
+gsm_dbus_client_init (GsmDBusClient *client)
+{
+}
+
+/* adapted from PolicyKit */
+static gboolean
+get_caller_info (GsmDBusClient *client,
+                 const char    *sender,
+                 uid_t         *calling_uid_out,
+                 pid_t         *calling_pid_out)
+{
+        g_autoptr(GDBusConnection) connection = NULL;
+        GError          *error;
+        g_autoptr(GVariant) uid_variant = NULL;
+        g_autoptr(GVariant) pid_variant = NULL;
+        uid_t            uid;
+        pid_t            pid;
+
+        if (sender == NULL) {
+                return FALSE;
+        }
+
+        error = NULL;
+        connection = g_bus_get_sync (G_BUS_TYPE_SESSION, NULL, &error);
+
+        if (error != NULL) {
+                g_warning ("error getting session bus: %s", error->message);
+                g_error_free (error);
+                return FALSE;
+        }
+
+        uid_variant = g_dbus_connection_call_sync (connection,
+                                                   "org.freedesktop.DBus",
+                                                   "/org/freedesktop/DBus",
+                                                   "org.freedesktop.DBus",
+                                                   "GetConnectionUnixUser",
+                                                   g_variant_new ("(s)", sender),
+                                                   G_VARIANT_TYPE ("(u)"),
+                                                   G_DBUS_CALL_FLAGS_NONE,
+                                                   -1, NULL, &error);
+
+        if (error != NULL) {
+                g_debug ("GetConnectionUnixUser() failed: %s", error->message);
+                g_error_free (error);
+                return FALSE;
+        }
+
+        pid_variant = g_dbus_connection_call_sync (connection,
+                                                   "org.freedesktop.DBus",
+                                                   "/org/freedesktop/DBus",
+                                                   "org.freedesktop.DBus",
+                                                   "GetConnectionUnixProcessID",
+                                                   g_variant_new ("(s)", sender),
+                                                   G_VARIANT_TYPE ("(u)"),
+                                                   G_DBUS_CALL_FLAGS_NONE,
+                                                   -1, NULL, &error);
+
+        if (error != NULL) {
+                g_debug ("GetConnectionUnixProcessID() failed: %s", error->message);
+                g_error_free (error);
+                return FALSE;
+        }
+
+        g_variant_get (uid_variant, "(u)", &uid);
+        g_variant_get (pid_variant, "(u)", &pid);
+
+        if (calling_uid_out != NULL) {
+                *calling_uid_out = uid;
+        }
+        if (calling_pid_out != NULL) {
+                *calling_pid_out = pid;
+        }
+
+        g_debug ("uid = %d", uid);
+        g_debug ("pid = %d", pid);
+
+        return TRUE;
+}
+
+static void
+on_client_vanished (GDBusConnection *connection,
+                    const char      *name,
+                    gpointer         user_data)
+{
+        GsmDBusClient  *client = user_data;
+
+        g_bus_unwatch_name (client->watch_id);
+        client->watch_id = 0;
+
+        gsm_client_disconnected (GSM_CLIENT (client));
+}
+
+static void
+gsm_dbus_client_set_bus_name (GsmDBusClient  *client,
+                              const char     *bus_name)
+{
+        g_return_if_fail (GSM_IS_DBUS_CLIENT (client));
+
+        g_free (client->bus_name);
+
+        client->bus_name = g_strdup (bus_name);
+        g_object_notify_by_pspec (G_OBJECT (client), props[PROP_BUS_NAME]);
+
+        if (!get_caller_info (client, bus_name, NULL, &client->caller_pid)) {
+                client->caller_pid = 0;
+        }
+
+        client->watch_id = g_bus_watch_name (G_BUS_TYPE_SESSION,
+                                                   bus_name,
+                                                   G_BUS_NAME_WATCHER_FLAGS_NONE,
+                                                   NULL,
+                                                   on_client_vanished,
+                                                   client,
+                                                   NULL);
+}
+
+const char *
+gsm_dbus_client_get_bus_name (GsmDBusClient  *client)
+{
+        g_return_val_if_fail (GSM_IS_DBUS_CLIENT (client), NULL);
+
+        return client->bus_name;
+}
+
+static void
+gsm_dbus_client_set_property (GObject       *object,
+                              guint          prop_id,
+                              const GValue  *value,
+                              GParamSpec    *pspec)
+{
+        GsmDBusClient *self = GSM_DBUS_CLIENT (object);
+
+        switch ((GsmDBusClientProperty) prop_id) {
+        case PROP_BUS_NAME:
+                gsm_dbus_client_set_bus_name (self, g_value_get_string (value));
+                break;
+        default:
+                G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
+                break;
+        }
+}
+
+static void
+gsm_dbus_client_get_property (GObject    *object,
+                              guint       prop_id,
+                              GValue     *value,
+                              GParamSpec *pspec)
+{
+        GsmDBusClient *self = GSM_DBUS_CLIENT (object);
+
+        switch ((GsmDBusClientProperty) prop_id) {
+        case PROP_BUS_NAME:
+                g_value_set_string (value, self->bus_name);
+                break;
+        default:
+                G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
+                break;
+        }
+}
+
+static void
+gsm_dbus_client_finalize (GObject *object)
+{
+        GsmDBusClient *client = (GsmDBusClient *) object;
+
+        g_free (client->bus_name);
+
+        if (client->skeleton != NULL) {
+                g_dbus_interface_skeleton_unexport_from_connection (G_DBUS_INTERFACE_SKELETON (client->skeleton),
+                                                                    client->connection);
+                g_clear_object (&client->skeleton);
+        }
+
+        g_clear_object (&client->connection);
+
+        if (client->watch_id != 0)
+                g_bus_unwatch_name (client->watch_id);
+
+        G_OBJECT_CLASS (gsm_dbus_client_parent_class)->finalize (object);
+}
+
+static GKeyFile *
+dbus_client_save (GsmClient *client,
+                  GsmApp    *app,
+                  GError   **error)
+{
+        g_debug ("GsmDBusClient: saving client with id %s",
+                 gsm_client_peek_id (client));
+
+        /* FIXME: We still don't support client saving for D-Bus
+         * session clients */
+
+        return NULL;
+}
+
+static gboolean
+dbus_client_stop (GsmClient *client,
+                  GError   **error)
+{
+        GsmDBusClient  *dbus_client = (GsmDBusClient *) client;
+        gsm_exported_client_private_emit_stop (dbus_client->skeleton);
+        return TRUE;
+}
+
+static char *
+dbus_client_get_app_name (GsmClient *client)
+{
+        /* Always use app-id instead */
+        return NULL;
+}
+
+static GsmClientRestartStyle
+dbus_client_get_restart_style_hint (GsmClient *client)
+{
+        return (GSM_DBUS_CLIENT (client)->restart_style_hint);
+}
+
+static guint
+dbus_client_get_unix_process_id (GsmClient *client)
+{
+        return (GSM_DBUS_CLIENT (client)->caller_pid);
+}
+
+static gboolean
+dbus_client_query_end_session (GsmClient                *client,
+                               GsmClientEndSessionFlag   flags,
+                               GError                  **error)
+{
+        GsmDBusClient  *dbus_client = (GsmDBusClient *) client;
+
+        if (dbus_client->bus_name == NULL) {
+                g_set_error (error,
+                             GSM_CLIENT_ERROR,
+                             GSM_CLIENT_ERROR_NOT_REGISTERED,
+                             "Client is not registered");
+                return FALSE;
+        }
+
+        g_debug ("GsmDBusClient: sending QueryEndSession signal to %s", dbus_client->bus_name);
+
+        gsm_exported_client_private_emit_query_end_session (dbus_client->skeleton, flags);
+        return TRUE;
+}
+
+static gboolean
+dbus_client_end_session (GsmClient                *client,
+                         GsmClientEndSessionFlag   flags,
+                         GError                  **error)
+{
+        GsmDBusClient  *dbus_client = (GsmDBusClient *) client;
+
+        gsm_exported_client_private_emit_end_session (dbus_client->skeleton, flags);
+        return TRUE;
+}
+
+static gboolean
+dbus_client_cancel_end_session (GsmClient *client,
+                                GError   **error)
+{
+        GsmDBusClient  *dbus_client = (GsmDBusClient *) client;
+        gsm_exported_client_private_emit_cancel_end_session (dbus_client->skeleton);
+        return TRUE;
+}
+
+static void
+gsm_dbus_client_class_init (GsmDBusClientClass *klass)
+{
+        GObjectClass   *object_class = G_OBJECT_CLASS (klass);
+        GsmClientClass *client_class = GSM_CLIENT_CLASS (klass);
+
+        object_class->finalize             = gsm_dbus_client_finalize;
+        object_class->constructor          = gsm_dbus_client_constructor;
+        object_class->get_property         = gsm_dbus_client_get_property;
+        object_class->set_property         = gsm_dbus_client_set_property;
+
+        client_class->impl_save                   = dbus_client_save;
+        client_class->impl_stop                   = dbus_client_stop;
+        client_class->impl_query_end_session      = dbus_client_query_end_session;
+        client_class->impl_end_session            = dbus_client_end_session;
+        client_class->impl_cancel_end_session     = dbus_client_cancel_end_session;
+        client_class->impl_get_app_name           = dbus_client_get_app_name;
+        client_class->impl_get_restart_style_hint = dbus_client_get_restart_style_hint;
+        client_class->impl_get_unix_process_id    = dbus_client_get_unix_process_id;
+
+        props[PROP_BUS_NAME] =
+                g_param_spec_string ("bus-name",
+                                     "bus-name",
+                                     "bus-name",
+                                     NULL,
+                                     G_PARAM_READWRITE | G_PARAM_CONSTRUCT | G_PARAM_STATIC_STRINGS | G_PARAM_EXPLICIT_NOTIFY);
+
+        g_object_class_install_properties (object_class, G_N_ELEMENTS (props), props);
+}
+
+GsmClient *
+gsm_dbus_client_new (const char *startup_id,
+                     const char *bus_name)
+{
+        GsmDBusClient *client;
+
+        client = g_object_new (GSM_TYPE_DBUS_CLIENT,
+                               "startup-id", startup_id,
+                               "bus-name", bus_name,
+                               NULL);
+
+        return GSM_CLIENT (client);
+}
diff --git a/gnome-session/gsm-dbus-client.h b/gnome-session/gsm-dbus-client.h
new file mode 100644
index 00000000..459d4963
--- /dev/null
+++ b/gnome-session/gsm-dbus-client.h
@@ -0,0 +1,35 @@
+/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
+ *
+ * Copyright (C) 2008 Red Hat, Inc.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __GSM_DBUS_CLIENT_H__
+#define __GSM_DBUS_CLIENT_H__
+
+#include "gsm-client.h"
+
+G_BEGIN_DECLS
+
+#define GSM_TYPE_DBUS_CLIENT            (gsm_dbus_client_get_type ())
+G_DECLARE_FINAL_TYPE (GsmDBusClient, gsm_dbus_client, GSM, DBUS_CLIENT, GsmClient)
+
+GsmClient *    gsm_dbus_client_new                (const char     *startup_id,
+                                                   const char     *bus_name);
+const char *   gsm_dbus_client_get_bus_name       (GsmDBusClient  *client);
+
+G_END_DECLS
+
+#endif /* __GSM_DBUS_CLIENT_H__ */
diff --git a/gnome-session/gsm-fail-whale-dialog.c b/gnome-session/gsm-fail-whale-dialog.c
new file mode 100644
index 00000000..9b2bca4f
--- /dev/null
+++ b/gnome-session/gsm-fail-whale-dialog.c
@@ -0,0 +1,195 @@
+/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
+ *
+ * Copyright (C) 2011,2025 Red Hat, Inc.
+ * Copyright (C) 2019 Canonical Ltd.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authors:
+ *        Colin Walters <walters@verbum.org>
+ *        Marco Trevisan <marco@ubuntu.com>
+ *        Adrian Vovk <adrianvovk@gmail.com>
+ */
+
+#include <config.h>
+
+#include <stdlib.h>
+
+#include <glib/gi18n.h>
+#include <gtk/gtk.h>
+
+#include "gsm-icon-names.h"
+
+typedef struct GsmFailContext {
+        GMainLoop *loop;
+        GList *monitors;
+
+        gboolean debug_mode;
+        gboolean allow_logout;
+        gboolean extensions;
+} GsmFailContext;
+
+static gboolean
+on_close_req (void)
+{
+        /* Suppress any further handling, including destruction of the window. */
+        return TRUE;
+}
+
+static void
+on_logout_clicked (GtkWidget      *button,
+                   GsmFailContext *ctx)
+{
+        if (!ctx->debug_mode) {
+                g_spawn_command_line_async ("gnome-session-quit --force", NULL);
+        }
+        g_main_loop_quit (ctx->loop);
+}
+
+static void
+create_fail_dialog (GdkMonitor     *monitor,
+                    GsmFailContext *ctx)
+{
+        GtkWindow *dialog;
+        GtkBox *box;
+        GtkImage *icon;
+        gchar *markup;
+        GtkLabel *title;
+        gchar *message_text;
+        GtkLabel *message;
+
+        dialog = GTK_WINDOW (gtk_window_new ());
+
+        gtk_window_set_title (dialog, "");
+        gtk_window_set_icon_name (dialog, GSM_ICON_COMPUTER_FAIL);
+
+        /* we only allow the window to be closed via on_monitors_changed */
+        gtk_window_set_deletable (dialog, FALSE);
+        g_signal_connect(dialog, "close-request", G_CALLBACK (on_close_req), NULL);
+
+        box = GTK_BOX (gtk_box_new (GTK_ORIENTATION_VERTICAL, 12));
+        gtk_widget_set_valign (GTK_WIDGET (box), GTK_ALIGN_CENTER);
+        gtk_window_set_child (dialog, GTK_WIDGET (box));
+
+        icon = GTK_IMAGE (gtk_image_new_from_icon_name (GSM_ICON_COMPUTER_FAIL));
+        gtk_image_set_pixel_size (icon, 128);
+        gtk_box_append (box, GTK_WIDGET (icon));
+
+
+        markup = g_strdup_printf ("<b><big>%s</big></b>", _("Oh no! Something has gone wrong."));
+        title = GTK_LABEL (gtk_label_new (markup));
+        gtk_label_set_use_markup (title, TRUE);
+        gtk_box_append (box, GTK_WIDGET (title));
+        g_free (markup);
+
+        if (!ctx->allow_logout)
+                message_text = _("A problem has occurred and the system can’t recover. Please contact a system administrator");
+        else if (ctx->extensions)
+                message_text = _("A problem has occurred and the system can’t recover. All extensions have been disabled as a precaution.");
+        else
+                message_text = _("A problem has occurred and the system can’t recover.\nPlease log out and try again.");
+        message = GTK_LABEL (gtk_label_new (message_text));
+        gtk_label_set_justify (message, GTK_JUSTIFY_CENTER);
+        gtk_label_set_wrap (message, TRUE);
+        gtk_box_append (box, GTK_WIDGET (message));
+
+        if (ctx->allow_logout) {
+                GtkButton *btn;
+                btn = GTK_BUTTON (gtk_button_new_with_mnemonic (_("_Log Out")));
+                gtk_widget_set_halign (GTK_WIDGET (btn), GTK_ALIGN_CENTER);
+                g_signal_connect (btn, "clicked",
+                                  G_CALLBACK (on_logout_clicked), ctx);
+                gtk_box_append (box, GTK_WIDGET (btn));
+        }
+
+        gtk_window_present (dialog);
+        gtk_window_fullscreen_on_monitor (dialog, monitor);
+
+        g_object_set_data_full (G_OBJECT (monitor), "gsm_fail_whale",
+                                dialog, (GDestroyNotify) gtk_window_destroy);
+}
+
+static void
+on_monitors_changed (GListModel     *monitors,
+                     guint           position,
+                     guint           removed,
+                     guint           added,
+                     GsmFailContext *ctx)
+{
+        GList *cursor;
+        guint i;
+
+        cursor = g_list_nth (ctx->monitors, position);
+
+        for (i = position; i < position + added; i++) {
+                GdkMonitor *monitor = GDK_MONITOR (g_list_model_get_item (monitors, i));
+                create_fail_dialog(monitor, ctx);
+                ctx->monitors = g_list_insert_before (ctx->monitors, cursor, monitor);
+        }
+
+        for (i = 0; i < removed; i++) {
+                GList *next = cursor->next;
+                g_object_unref (G_OBJECT (cursor->data));
+                ctx->monitors = g_list_delete_link (ctx->monitors, cursor);
+                cursor = next;
+        }
+}
+
+int main (int argc, char *argv[])
+{
+        GsmFailContext ctx = {};
+        GOptionEntry entries[] = {
+                { "debug", 0, 0, G_OPTION_ARG_NONE, &ctx.debug_mode, N_("Enable debugging code"), NULL },
+                { "allow-logout", 0, 0, G_OPTION_ARG_NONE, &ctx.allow_logout, N_("Allow logout"), NULL },
+                { "extensions", 0, 0, G_OPTION_ARG_NONE, &ctx.extensions, N_("Show extension warning"), NULL },
+                { NULL, 0, 0, 0, NULL, NULL, NULL }
+        };
+
+        GError *error = NULL;
+        GOptionContext *opts;
+        GListModel *monitors;
+
+        bindtextdomain (GETTEXT_PACKAGE, LOCALE_DIR);
+        bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
+        textdomain (GETTEXT_PACKAGE);
+
+        opts = g_option_context_new (" - fail whale");
+        g_option_context_add_main_entries (opts, entries, GETTEXT_PACKAGE);
+        if (!g_option_context_parse (opts, &argc, &argv, &error)) {
+                g_warning ("%s", error->message);
+                exit (1);
+        }
+        g_option_context_free (opts);
+
+        /* Force-off allow_logout when running inside GDM, this is needed
+         * because the systemd service always passes --allow-logout
+         */
+        if (g_strcmp0 (g_getenv ("RUNNING_UNDER_GDM"), "true") == 0)
+                ctx.allow_logout = FALSE;
+
+        gtk_init ();
+        ctx.loop = g_main_loop_new (NULL, TRUE);
+
+        monitors = gdk_display_get_monitors (gdk_display_get_default ());
+        on_monitors_changed(monitors, 0, 0, g_list_model_get_n_items (monitors), &ctx);
+        g_signal_connect (monitors, "items-changed", G_CALLBACK (on_monitors_changed), &ctx);
+
+        g_main_loop_run (ctx.loop);
+
+        g_main_loop_unref (ctx.loop);
+        g_list_free_full (ctx.monitors, g_object_unref);
+
+        return 0;
+}
+
